using System;
using Server.Items;

namespace Server.ContextMenus
{
	public class OpenBankEntry : ContextMenuEntry
	{
		private Mobile m_Banker;

		public OpenBankEntry( Mobile from, Mobile banker ) : base( 6105, from.InRange( banker, 12 ) )
		{
			m_Banker = banker;
		}

		public override void OnClick()
		{
			if ( this.Owner.From.InRange( m_Banker, 12 ) )
			{
				BankBox box = this.Owner.From.BankBox;

				if ( box != null )
					box.Open();
			}
		}
	}
}