using System;
using Server;

namespace Server.Scripts.Items.Potions
{
	public abstract class BaseAgilityPotion : BasePotion
	{
		public abstract int DexOffset{ get; }
		public abstract TimeSpan Duration{ get; }

		public BaseAgilityPotion( PotionEffect effect ) : base( 0xF08, effect )
		{
		}

		public BaseAgilityPotion( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}

		public void DoAgility( Mobile from )
		{
			from.AddStatMod( new StatMod( StatType.Dex, "[Potion] Dex Offset", DexOffset, Duration ) );
		}

		public override void Drink( Mobile from )
		{
			DoAgility( from );

			BasePotion.PlayDrinkEffect( from );

			this.Delete();
		}
	}
}