using System;
using Server;

namespace Server.Scripts.Items.Potions
{
	public class CurePotion : BaseCurePotion
	{
		private static CureLevelInfo[] m_LevelInfo = new CureLevelInfo[]
			{
				new CureLevelInfo( Poison.Lesser, 1.0 ), // 100% chance to cure lesser poison
				new CureLevelInfo( Poison.Regular, 0.75 ) // 75% chance to cure regular poison
			};

		public override CureLevelInfo[] LevelInfo{ get{ return m_LevelInfo; } }

		[Constructable]
		public CurePotion() : base( PotionEffect.Cure )
		{
		}

		public CurePotion( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}