using System;
using Server;

namespace Server.Scripts.Items.Potions
{
	public abstract class BaseStrengthPotion : BasePotion
	{
		public abstract int StrOffset{ get; }
		public abstract TimeSpan Duration{ get; }

		public BaseStrengthPotion( PotionEffect effect ) : base( 0xF09, effect )
		{
		}

		public BaseStrengthPotion( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}

		public void DoStrength( Mobile from )
		{
			from.AddStatMod( new StatMod( StatType.Str, "[Potion] Str Offset", StrOffset, Duration ) );
		}

		public override void Drink( Mobile from )
		{
			DoStrength( from );

			BasePotion.PlayDrinkEffect( from );

			this.Delete();
		}
	}
}