using System;

namespace Server.Items
{
	public enum TrapType
	{
		None,
		MagicTrap
	}

	public abstract class TrapableContainer : Container
	{
		private TrapType m_Type;

		[CommandProperty( AccessLevel.GameMaster )]
		public TrapType Type
		{
			get
			{
				return m_Type;
			}
			set
			{
				m_Type = value;
			}
		}

		public TrapableContainer( int itemID, int gumpID, int defaultDropSound, Rectangle2D bounds ) : base( itemID, gumpID, defaultDropSound, bounds )
		{
		}

		public TrapableContainer( Serial serial ) : base( serial )
		{
		}

		public override void OnDoubleClick( Mobile from )
		{
			if ( m_Type != TrapType.None )
			{
				// TODO: Invoke trap
				m_Type = TrapType.None;
			}
			else
			{
				base.OnDoubleClick( from );
			}
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version

			writer.Write( (int) m_Type );
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();

			switch ( version )
			{
				case 0:
				{
					m_Type = (TrapType)reader.ReadInt();

					break;
				}
			}
		}
	}
}