using System;
using System.Net;
using Server;
using Server.Network;

namespace Server.Scripts.Misc
{
	public class ServerList
	{
		public static void Initialize()
		{
			EventSink.ServerList += new ServerListEventHandler( EventSink_ServerList );
		}

		public static void EventSink_ServerList( ServerListEventArgs e )
		{
			IPHostEntry thisHost = Dns.Resolve( Dns.GetHostName() );
			IPAddress[] addressList = thisHost.AddressList;

			if ( addressList.Length > 0 )
			{
				e.AddServer( "RunUO Test Center", new IPEndPoint( addressList[addressList.Length - 1], 2593 ) );

				// If you're running behind a router, use the following line instead:
				// e.AddServer( "RunUO Test Center", new IPEndPoint( IPAddress.Parse( "__PUT_YOUR_IP_HERE_" ), 2593 ) );
			}
			else
			{
				e.Rejected = true;
			}
		}
	}
}