using System;
using System.Collections;
using Server.Spells;
using Server.Spells.First;
using Server.Spells.Second;
using Server.Spells.Third;
using Server.Spells.Fourth;
using Server.Spells.Fifth;
using Server.Spells.Sixth;
using Server.Spells.Seventh;
using Server.Targeting;

namespace Server.Scripts.Mobiles.Monsters.Magical
{
	public class Daemon : BaseAggressive
	{
		[Constructable]
		public Daemon()
		{
			this.Body = 0x9;
			this.Name = "a daemon";

			this.InitStats( 550, 500, 550 );

			this.Skills[SkillName.Wrestling].Base = 120.0;
			this.Skills[SkillName.Tactics].Base = 120.0;
			this.Skills[SkillName.Anatomy].Base = 120.0;
			this.Skills[SkillName.MagicResist].Base = 120.0;
			this.Skills[SkillName.Magery].Base = 120.0;
			this.Skills[SkillName.EvalInt].Base = 120.0;
			this.Skills[SkillName.Meditation].Base = 120.0;
		}

		public Daemon( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}

		public override double GetValueFrom( Mobile m )
		{
			return -this.GetDistanceToSqrt( m );
		}
	}
}