using System;
using Server.Targeting;

namespace Server.SkillHandlers
{
	public class EvalInt
	{
		public static void Initialize()
		{
			SkillInfo.Table[16].Callback = new SkillUseCallback( OnUse );
		}

		public static TimeSpan OnUse( Mobile m )
		{
			m.Target = new EvalInt.InternalTarget();
			m.RevealingAction();

			m.SendLocalizedMessage( 500906 ); // What do you wish to evaluate?

			return TimeSpan.FromSeconds( 10.0 );
		}

		private class InternalTarget : Target
		{
			public InternalTarget() :  base ( 5, false, TargetFlags.None )
			{
			}

			protected override void OnTarget( Mobile from, object targeted )
			{
				if ( targeted is Mobile )
				{
					Mobile targ = (Mobile)targeted;
					int body = 0;
					int intMod = targ.Int / 10;
					int mnMod = targ.Mana / targ.ManaMax * 10;
					
					if ( intMod > 10 ) intMod = 10;
					else if ( intMod < 0 ) intMod = 0;

					if ( mnMod > 10 ) mnMod = 10;
					else if ( mnMod < 0 ) mnMod = 0;

					if ( targ.Body.IsFemale )
						body = 11;
					else if ( !targ.Body.IsHuman )
						body = 22;

					if ( from.CheckSkill( SkillName.EvalInt, 0, 100 ) )
					{
						from.SendLocalizedMessage( 1038169 + intMod + body ); // He/She/It looks [slighly less intelligent than a rock.]  [Of Average intellect] [etc...]

						if ( from.Skills[SkillName.EvalInt].Value > 75 )
							from.SendLocalizedMessage( 1038202 + mnMod ); // That being is at [10,20,...] percent mental strength.
					} 
					else 
					{
						from.SendLocalizedMessage( 1038066 + (body / 11) ); // You cannot judge his/her/its mental abilities.
					}
				} 
				else 
				{
					from.SendLocalizedMessage( 500908 ); // It looks smarter than a rock, but dumber than a piece of wood.
				}
			}
		}
	}
}


