// Agility Spell Script v.1.0 by SickLab (2002-09-28)
// Touchups by Krrios

using System;
using Server.Targeting;
using Server.Network;

namespace Server.Spells.Second
{
	public class AgilitySpell : Spell
	{
		private static SpellInfo m_Info = new SpellInfo(
				"Agility", "Ex Uus",
				SpellCircle.Second,
				212,
				Reagent.Bloodmoss,
				Reagent.MandrakeRoot
			);

		public AgilitySpell( Mobile caster, Server.Items.SpellScroll scroll ) : base( caster, scroll, m_Info )
		{
		}

		public override void OnCast()
		{
			Caster.Target = new InternalTarget( this );
		}

		public void Target( Mobile m )
		{
			if ( !Caster.CanSee( m ) )
			{
				Caster.SendLocalizedMessage( 500237 ); // Target can not be seen.
			}
			else if ( Caster.BeneficialCheck( m ) && CheckSequence() )
			{
				int increase = 1 + (int)(Caster.Skills[SkillName.Magery].Value * 0.1);
				TimeSpan duration = TimeSpan.FromSeconds( Caster.Skills[SkillName.Magery].Value * 1.2 );

				m.AddStatMod( new StatMod( StatType.Dex, "[Spell] Dex Offset", + increase, duration ) );

				if ( Caster != m )
					Caster.Direction = Caster.GetDirectionTo( m ); 

				m.PlaySound( 0x28E );
				Effects.SendTargetEffect( m, 0x375A, 15 );
			}

			FinishSequence();
		}

		private class InternalTarget : Target
		{
			private AgilitySpell m_Owner;

			public InternalTarget( AgilitySpell owner ) : base( 12, false, TargetFlags.Beneficial )
			{
				m_Owner = owner;
			} 

			protected override void OnTarget( Mobile from, object o )
			{
				if ( o is Mobile )
				{
					m_Owner.Target( (Mobile)o );
				}
			}

			protected override void OnTargetFinish( Mobile from )
			{
				m_Owner.FinishSequence();
			}
		}
	}
}